

<!DOCTYPE html>
<html class="writer-html5" lang="en" >
<head>
  <meta charset="utf-8" />
  
  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  
  <title>The PSyGrid Object &mdash; posydon 0+untagged.3754.gf69f455.dirty documentation</title>
  

  
  <link rel="stylesheet" href="../_static/css/theme.css" type="text/css" />
  <link rel="stylesheet" href="../_static/pygments.css" type="text/css" />

  
  

  
  

  

  
  <!--[if lt IE 9]>
    <script src="../_static/js/html5shiv.min.js"></script>
  <![endif]-->
  
    
      <script type="text/javascript" id="documentation_options" data-url_root="../" src="../_static/documentation_options.js"></script>
        <script src="../_static/jquery.js"></script>
        <script src="../_static/underscore.js"></script>
        <script src="../_static/doctools.js"></script>
        <script src="../_static/language_data.js"></script>
    
    <script type="text/javascript" src="../_static/js/theme.js"></script>

    
    <link rel="index" title="Index" href="../genindex.html" />
    <link rel="search" title="Search" href="../search.html" />
    <link rel="next" title="Showcase of 2D plotting functionalities" href="plot2D/plot2D.html" />
    <link rel="prev" title="Run a Fixed MESA Grid" href="../run_mesa_grids/fixed/fixed.html" /> 
</head>

<body class="wy-body-for-nav">

   
  <div class="wy-grid-for-nav">
    
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >
          

          
            <a href="../index.html" class="icon icon-home"> posydon
          

          
          </a>

          
            
            
              <div class="version">
                0+untagged.3754.gf69f455.dirty
              </div>
            
          

          
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>

          
        </div>

        
        <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
          
            
            
              
            
            
              <ul class="current">
<li class="toctree-l1"><a class="reference internal" href="../install/index.html">Installation</a></li>
<li class="toctree-l1"><a class="reference internal" href="../run_mesa_grids/inifile.html">Configuration files for POSYDON</a></li>
<li class="toctree-l1"><a class="reference internal" href="../run_mesa_grids/dynamic/dynamic.html">Run a Dynamic MESA Grid</a></li>
<li class="toctree-l1"><a class="reference internal" href="../run_mesa_grids/fixed/fixed.html">Run a Fixed MESA Grid</a></li>
<li class="toctree-l1 current"><a class="current reference internal" href="#">The PSyGrid Object</a><ul>
<li class="toctree-l2"><a class="reference internal" href="#creating-a-psygrid-object">Creating a PSyGrid object</a><ul>
<li class="toctree-l3"><a class="reference internal" href="#basic-example">Basic example</a></li>
<li class="toctree-l3"><a class="reference internal" href="#output-options">Output options</a></li>
<li class="toctree-l3"><a class="reference internal" href="#setting-the-properties-of-the-grid">Setting the properties of the grid</a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="#loading-an-existing-psygrid-object">Loading an existing PSyGrid object</a></li>
<li class="toctree-l2"><a class="reference internal" href="#closing-deleting-a-psygrid-object">Closing/deleting a PSyGrid object</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="plot2D/plot2D.html">Showcase of 2D plotting functionalities</a></li>
<li class="toctree-l1"><a class="reference internal" href="plot1D/plot1D.html">Showcase of 1D plotting functionalities</a></li>
<li class="toctree-l1"><a class="reference internal" href="../SingleStar/SingleStar.html">The Single Star Object</a></li>
<li class="toctree-l1"><a class="reference internal" href="../BinaryStar/BinaryStar.html">The Binary Star Object</a></li>
<li class="toctree-l1"><a class="reference internal" href="../visualization/VH_diagram.html">Van den Heuvel diagrams</a></li>
</ul>

            
          
        </div>
        
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">

      
      <nav class="wy-nav-top" aria-label="top navigation">
        
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="../index.html">posydon</a>
        
      </nav>


      <div class="wy-nav-content">
        
        <div class="rst-content">
        
          

















<div role="navigation" aria-label="breadcrumbs navigation">

  <ul class="wy-breadcrumbs">
    
      <li><a href="../index.html" class="icon icon-home"></a> &raquo;</li>
        
      <li>The PSyGrid Object</li>
    
    
      <li class="wy-breadcrumbs-aside">
        
          
            <a href="../_sources/PSyGrid/PSyGrid.rst.txt" rel="nofollow"> View page source</a>
          
        
      </li>
    
  </ul>

  
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
            
  <div class="section" id="the-psygrid-object">
<span id="psygrid"></span><h1>The PSyGrid Object<a class="headerlink" href="#the-psygrid-object" title="Permalink to this headline">¶</a></h1>
<p>The PSyGrid class is the “bridge” connecting MESA and POSYDON. It:</p>
<ul class="simple">
<li><p>encapsulates the data from a MESA grid in a compact form</p></li>
<li><p>saves the data in an HDF5 file</p></li>
<li><p>allows the user to access the data in a memory-efficient way</p></li>
</ul>
<p>To use PSyGrid import it using:</p>
<div class="highlight-python notranslate"><div class="highlight"><pre><span></span><span class="kn">from</span> <span class="nn">posydon.grids.psygrid</span> <span class="kn">import</span> <span class="n">PSyGrid</span>
</pre></div>
</div>
<div class="section" id="creating-a-psygrid-object">
<h2>Creating a PSyGrid object<a class="headerlink" href="#creating-a-psygrid-object" title="Permalink to this headline">¶</a></h2>
<p>A PSyGrid HDF5 file can be created by using the <code class="docutils literal notranslate"><span class="pre">create()</span></code> method on a newly
constructed PSyGrid object.</p>
<div class="section" id="basic-example">
<h3>Basic example<a class="headerlink" href="#basic-example" title="Permalink to this headline">¶</a></h3>
<p>The simplest method is to provide the paths of the folder of the MESA runs
output, and the HDF5 file to be created.</p>
<div class="highlight-python notranslate"><div class="highlight"><pre><span></span><span class="n">grid</span> <span class="o">=</span> <span class="n">PSyGrid</span><span class="p">()</span>
<span class="n">grid</span><span class="o">.</span><span class="n">create</span><span class="p">(</span><span class="n">MESA_runs_directory</span><span class="p">,</span> <span class="n">psygrid_hdf5_path</span><span class="p">)</span>
</pre></div>
</div>
<p>Now, the PSyGrid object is ready to be used for accessing and plotting data.</p>
</div>
<div class="section" id="output-options">
<h3>Output options<a class="headerlink" href="#output-options" title="Permalink to this headline">¶</a></h3>
<p>Use the option <code class="docutils literal notranslate"><span class="pre">verbose</span></code> to see more details while the PSyGrid objects is
being built.</p>
<p>Set <code class="docutils literal notranslate"><span class="pre">overwrite</span></code> to <code class="docutils literal notranslate"><span class="pre">True</span></code> if the HDF5 file already exists.</p>
<p>By default, any warnings produced are collected and shown at the end
(<code class="docutils literal notranslate"><span class="pre">warn=&quot;end&quot;</span></code>) of the process. Use <code class="docutils literal notranslate"><span class="pre">warn=&quot;normal&quot;</span></code> to see the warning
when they occur, or <code class="docutils literal notranslate"><span class="pre">warn=&quot;suppress&quot;</span></code> to hide them completely.</p>
<div class="highlight-python notranslate"><div class="highlight"><pre><span></span><span class="n">grid</span> <span class="o">=</span> <span class="n">PSyGrid</span><span class="p">()</span>
<span class="n">grid</span><span class="o">.</span><span class="n">create</span><span class="p">(</span><span class="n">MESA_runs_directory</span><span class="p">,</span> <span class="n">psygrid_hdf5_path</span><span class="p">,</span>
            <span class="n">verbose</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span> <span class="n">overwrite</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span> <span class="n">warn</span><span class="o">=</span><span class="s2">&quot;suppress&quot;</span><span class="p">)</span>
</pre></div>
</div>
</div>
<div class="section" id="setting-the-properties-of-the-grid">
<h3>Setting the properties of the grid<a class="headerlink" href="#setting-the-properties-of-the-grid" title="Permalink to this headline">¶</a></h3>
<p>PSyGrid provides a compact form of the initial MESA grid. To define how many runs should be included (e.g. for testing purposes),
and which data columns are needed, use the following code block as a guide.</p>
<div class="highlight-python notranslate"><div class="highlight"><pre><span></span><span class="n">DEFAULT_BINARY_HISTORY_COLS</span> <span class="o">=</span> <span class="p">[</span><span class="s1">&#39;star_1_mass&#39;</span><span class="p">,</span> <span class="s1">&#39;star_2_mass&#39;</span><span class="p">,</span> <span class="s1">&#39;period_days&#39;</span><span class="p">,</span> <span class="s1">&#39;binary_separation&#39;</span><span class="p">,</span> <span class="s1">&#39;age&#39;</span><span class="p">,</span> <span class="s1">&#39;rl_relative_overflow_1&#39;</span><span class="p">,</span> <span class="s1">&#39;rl_relative_overflow_2&#39;</span><span class="p">,</span> <span class="s1">&#39;lg_mtransfer_rate&#39;</span><span class="p">]</span>
<span class="n">DEFAULT_STAR_HISTORY_COLS</span> <span class="o">=</span> <span class="p">[</span><span class="s1">&#39;star_age&#39;</span><span class="p">,</span> <span class="s1">&#39;star_mass&#39;</span><span class="p">,</span> <span class="s1">&#39;he_core_mass&#39;</span><span class="p">,</span> <span class="s1">&#39;c_core_mass&#39;</span><span class="p">,</span> <span class="s1">&#39;center_h1&#39;</span><span class="p">,</span> <span class="s1">&#39;center_he4&#39;</span><span class="p">,</span> <span class="s1">&#39;c12_c12&#39;</span><span class="p">,</span> <span class="s1">&#39;center_c12&#39;</span><span class="p">,</span> <span class="s1">&#39;log_LH&#39;</span><span class="p">,</span> <span class="s1">&#39;log_LHe&#39;</span><span class="p">,</span> <span class="s1">&#39;log_LZ&#39;</span><span class="p">,</span> <span class="s1">&#39;log_Lnuc&#39;</span><span class="p">,</span> <span class="s1">&#39;surface_h1&#39;</span><span class="p">,</span> <span class="s1">&#39;log_Teff&#39;</span><span class="p">,</span> <span class="s1">&#39;log_L&#39;</span><span class="p">]</span>
<span class="n">DEFAULT_PROFILE_COLS</span> <span class="o">=</span> <span class="p">[</span><span class="s1">&#39;radius&#39;</span><span class="p">,</span> <span class="s1">&#39;mass&#39;</span><span class="p">,</span> <span class="s1">&#39;logRho&#39;</span><span class="p">,</span> <span class="s1">&#39;omega&#39;</span><span class="p">]</span>

<span class="n">GRIDPROPERTIES</span> <span class="o">=</span> <span class="p">{</span>
    <span class="c1"># file loading parameters</span>
    <span class="s2">&quot;description&quot;</span><span class="p">:</span> <span class="s2">&quot;&quot;</span><span class="p">,</span>                      <span class="c1"># description text</span>
    <span class="s2">&quot;max_number_of_runs&quot;</span><span class="p">:</span> <span class="kc">None</span><span class="p">,</span>
    <span class="s2">&quot;format&quot;</span><span class="p">:</span> <span class="s2">&quot;hdf5&quot;</span><span class="p">,</span>
    <span class="c1"># resampling parameters</span>
    <span class="s2">&quot;n_downsample_history&quot;</span><span class="p">:</span> <span class="kc">None</span><span class="p">,</span>           <span class="c1"># False/None = no hist. resampling</span>
    <span class="s2">&quot;n_downsample_profile&quot;</span><span class="p">:</span> <span class="kc">None</span><span class="p">,</span>           <span class="c1"># False/None = no prof. resampling</span>
    <span class="s2">&quot;history_resample_columns&quot;</span><span class="p">:</span> <span class="n">DEFAULT_HISTORY_DOWNSAMPLE_COLS</span><span class="p">,</span>
    <span class="s2">&quot;profile_resample_columns&quot;</span><span class="p">:</span> <span class="n">DEFAULT_PROFILE_DOWNSAMPLE_COLS</span><span class="p">,</span>
    <span class="c1"># columns to pass to the grid</span>
    <span class="s2">&quot;star1_history_saved_columns&quot;</span><span class="p">:</span> <span class="n">DEFAULT_STAR_HISTORY_COLS</span><span class="p">,</span>
    <span class="s2">&quot;star2_history_saved_columns&quot;</span><span class="p">:</span> <span class="n">DEFAULT_STAR_HISTORY_COLS</span><span class="p">,</span>
    <span class="s2">&quot;binary_history_saved_columns&quot;</span><span class="p">:</span> <span class="n">DEFAULT_BINARY_HISTORY_COLS</span><span class="p">,</span>
    <span class="s2">&quot;star1_profile_saved_columns&quot;</span><span class="p">:</span> <span class="n">DEFAULT_PROFILE_COLS</span><span class="p">,</span>
    <span class="s2">&quot;star2_profile_saved_columns&quot;</span><span class="p">:</span> <span class="n">DEFAULT_PROFILE_COLS</span><span class="p">,</span>
    <span class="c1"># Initial/Final value arrays</span>
    <span class="s2">&quot;initial_value_columns&quot;</span><span class="p">:</span> <span class="kc">None</span><span class="p">,</span>
    <span class="s2">&quot;final_value_columns&quot;</span><span class="p">:</span> <span class="kc">None</span><span class="p">,</span>
<span class="p">}</span>

<span class="n">grid</span> <span class="o">=</span> <span class="n">PSyGrid</span><span class="p">()</span>
<span class="n">grid</span><span class="o">.</span><span class="n">create</span><span class="p">(</span><span class="n">MESA_runs_directory</span><span class="p">,</span> <span class="n">psygrid_path</span><span class="p">,</span> <span class="o">**</span><span class="n">GRIDPROPERTIES</span><span class="p">)</span>
</pre></div>
</div>
</div>
</div>
<div class="section" id="loading-an-existing-psygrid-object">
<h2>Loading an existing PSyGrid object<a class="headerlink" href="#loading-an-existing-psygrid-object" title="Permalink to this headline">¶</a></h2>
<p>To load a PSyGrid object from an HDF5 file you only need its path:</p>
<div class="highlight-python notranslate"><div class="highlight"><pre><span></span><span class="n">grid</span> <span class="o">=</span> <span class="n">PSyGrid</span><span class="p">(</span><span class="s1">&#39;/home/mydata/my_MESA_grid&#39;</span><span class="p">)</span>
</pre></div>
</div>
</div>
<div class="section" id="closing-deleting-a-psygrid-object">
<h2>Closing/deleting a PSyGrid object<a class="headerlink" href="#closing-deleting-a-psygrid-object" title="Permalink to this headline">¶</a></h2>
<p>As with files in Python, it is preferable to “close” PSyGrid objects after
handling them.</p>
<p>The <code class="docutils literal notranslate"><span class="pre">.close()</span></code> method closes the HDF5 file associated to the PSyGrid object.
However, the object continues to exist and hold all the metadata.</p>
<div class="highlight-python notranslate"><div class="highlight"><pre><span></span><span class="n">grid</span><span class="o">.</span><span class="n">close</span><span class="p">()</span>
</pre></div>
</div>
<p>In the case that a PSyGrid object is not needed anymore,
use the <code class="docutils literal notranslate"><span class="pre">del</span></code> keyword. Note that this also closes the HDF5 file.</p>
<div class="highlight-python notranslate"><div class="highlight"><pre><span></span><span class="k">del</span> <span class="n">grid</span>
</pre></div>
</div>
</div>
</div>


           </div>
           
          </div>
          <footer>
    <div class="rst-footer-buttons" role="navigation" aria-label="footer navigation">
        <a href="plot2D/plot2D.html" class="btn btn-neutral float-right" title="Showcase of 2D plotting functionalities" accesskey="n" rel="next">Next <span class="fa fa-arrow-circle-right" aria-hidden="true"></span></a>
        <a href="../run_mesa_grids/fixed/fixed.html" class="btn btn-neutral float-left" title="Run a Fixed MESA Grid" accesskey="p" rel="prev"><span class="fa fa-arrow-circle-left" aria-hidden="true"></span> Previous</a>
    </div>

  <hr/>

  <div role="contentinfo">
    <p>
        &#169; Copyright 2019, Tassos Fragkos.

    </p>
  </div>
    
    
    
    Built with <a href="https://www.sphinx-doc.org/">Sphinx</a> using a
    
    <a href="https://github.com/readthedocs/sphinx_rtd_theme">theme</a>
    
    provided by <a href="https://readthedocs.org">Read the Docs</a>. 

</footer>
        </div>
      </div>

    </section>

  </div>
  

  <script type="text/javascript">
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script>

  
  
    
   

</body>
</html>